//+------------------------------------------------------------------+
//|                             normalized deviations oscillator.mq4 |
//|                                                           mladen |
//|                                                                  |
//| original developed by William Cringan (TASC 2/2003)              |
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    NdoPrice    = PRICE_CLOSE;
extern int    EMAPeriod   = 7;
extern int    NormPeriod  = 80;

//
//
//
//
//

double ndoUp[];
double ndoDn[];
double ndo[];
double dos[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,ndoUp); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,ndoDn); SetIndexStyle(1,DRAW_HISTOGRAM);   
      SetIndexBuffer(2,ndo);
      SetIndexBuffer(3,dos);
      SetIndexBuffer(4,trend);
   IndicatorShortName("Directional Normalized Juice");
return(0);
}
int deinit(){ return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      dos[i] = iMA(NULL,0,1,0,MODE_SMA,NdoPrice,i) - iMA(NULL,0,EMAPeriod,0,MODE_EMA,NdoPrice,i);
      
         //
         //
         //
         //
         //
         
         double hi = dos[ArrayMaximum(dos,NormPeriod,i)];
         double lo = dos[ArrayMinimum(dos,NormPeriod,i)];
         if (dos[i]>0)
               if (hi!=0)
                     ndo[i] = 100*dos[i]/hi;
               else  ndo[i] = 0;
         else  
               if (lo!=0)
                     ndo[i] = 100*dos[i]/MathAbs(lo);
               else  ndo[i] = 0;
         ndo[i]   = MathMin(MathMax(ndo[i],-100),100);
         
         //
         //
         //
         //
         //
         
         ndoUp[i] = EMPTY_VALUE;
         ndoDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (ndo[i]>0) trend[i] = 1;
            if (ndo[i]<0) trend[i] =-1;
            if (trend[i] == 1) ndoUp[i] = ndo[i];
            if (trend[i] ==-1) ndoDn[i] = ndo[i];
   }
   return(0);         
}


